Index: code/branches/input/src/orxonox/GraphicsEngine.cc
===================================================================
--- code/branches/input/src/orxonox/GraphicsEngine.cc	(revision 968)
+++ code/branches/input/src/orxonox/GraphicsEngine.cc	(revision 969)
@@ -63,6 +63,13 @@
   GraphicsEngine::~GraphicsEngine()
   {
-    if (!this->root_)
+    if (this->root_)
       delete this->root_;
+    // delete the ogre log and the logManager (sine we have created it).
+    if (LogManager::getSingletonPtr() != 0)
+    {
+      LogManager::getSingleton().getDefaultLog()->removeListener(this);
+      LogManager::getSingleton().destroyLog(LogManager::getSingleton().getDefaultLog());
+      delete LogManager::getSingletonPtr();
+    }
   }
 
Index: code/branches/input/src/orxonox/GraphicsEngine.h
===================================================================
--- code/branches/input/src/orxonox/GraphicsEngine.h	(revision 968)
+++ code/branches/input/src/orxonox/GraphicsEngine.h	(revision 969)
@@ -28,5 +28,5 @@
     public:
       GraphicsEngine();
-      inline void setConfigPath(std::string path) { this->configPath_ = path; };
+      void setConfigPath(std::string path) { this->configPath_ = path; };
       // find a better way for this
       //inline Ogre::Root* getRoot() { return root_; };
Index: code/branches/input/src/orxonox/InputHandler.cc
===================================================================
--- code/branches/input/src/orxonox/InputHandler.cc	(revision 968)
+++ code/branches/input/src/orxonox/InputHandler.cc	(revision 969)
@@ -166,5 +166,5 @@
     @brief Destroys the singleton.
   */
-  void InputHandler::destroy()
+  void InputHandler::destroySingleton()
   {
     if (singletonRef_s)
@@ -179,4 +179,5 @@
   void InputHandler::tick(float dt)
   {
+    //this->mouse_->setEventCallback(this);
     // capture all the input. That calls the event handlers.
     if (mouse_)
@@ -251,4 +252,5 @@
   bool InputHandler::mousePressed(const OIS::MouseEvent &e, OIS::MouseButtonID id)
   {
+    COUT(1) << "asdf" << std::endl;
     return true;
   }
Index: code/branches/input/src/orxonox/InputHandler.h
===================================================================
--- code/branches/input/src/orxonox/InputHandler.h	(revision 968)
+++ code/branches/input/src/orxonox/InputHandler.h	(revision 969)
@@ -63,5 +63,5 @@
 
     static InputHandler* getSingleton();
-    static void destroy();
+    static void destroySingleton();
 
   private:
Index: code/branches/input/src/orxonox/Main.cc
===================================================================
--- code/branches/input/src/orxonox/Main.cc	(revision 968)
+++ code/branches/input/src/orxonox/Main.cc	(revision 969)
@@ -84,5 +84,5 @@
 
     orx->start();
-    orx->destroy();
+    orx->destroySingleton();
   }
   catch (std::exception &ex)
Index: code/branches/input/src/orxonox/Orxonox.cc
===================================================================
--- code/branches/input/src/orxonox/Orxonox.cc	(revision 968)
+++ code/branches/input/src/orxonox/Orxonox.cc	(revision 969)
@@ -108,5 +108,5 @@
       delete this->orxonoxHUD_;
     Loader::close();
-    InputHandler::destroy();
+    InputHandler::destroySingleton();
     if (this->auMan_)
       delete this->auMan_;
@@ -154,5 +154,5 @@
     @brief Destroys the Orxonox singleton.
   */
-  void Orxonox::destroy()
+  void Orxonox::destroySingleton()
   {
     if (singletonRef_s)
Index: code/branches/input/src/orxonox/Orxonox.h
===================================================================
--- code/branches/input/src/orxonox/Orxonox.h	(revision 968)
+++ code/branches/input/src/orxonox/Orxonox.h	(revision 969)
@@ -44,5 +44,5 @@
 
       static Orxonox* getSingleton();
-      static void destroy();
+      static void destroySingleton();
 
    private:
Index: code/branches/input/src/orxonox/OrxonoxPlatform.h
===================================================================
--- code/branches/input/src/orxonox/OrxonoxPlatform.h	(revision 968)
+++ code/branches/input/src/orxonox/OrxonoxPlatform.h	(revision 969)
@@ -270,3 +270,6 @@
 } /* namespace orxonox */
 
+// include visual leak detector to search for memory links
+// #include <vld.h>
+
 #endif /* _OrxonoxPlatform_H__ */
Index: code/branches/input/src/orxonox/OrxonoxStableHeaders.h
===================================================================
--- code/branches/input/src/orxonox/OrxonoxStableHeaders.h	(revision 968)
+++ code/branches/input/src/orxonox/OrxonoxStableHeaders.h	(revision 969)
@@ -40,9 +40,9 @@
 // including std headers here is useless since they're already precompiled
 
-// not including the entire Ogre.h doesn't exceed the default heap size for pch
 #ifndef WIN32_LEAN_AND_MEAN
 // prevent Ogre from including winsock.h that messes with winsock2.h from enet
 #  define WIN32_LEAN_AND_MEAN
 #endif
+// not including the entire Ogre.h doesn't exceed the default heap size for pch
 //#include <Ogre.h>
 #include <OgreBillboardSet.h>
Index: code/branches/input/src/orxonox/core/Factory.h
===================================================================
--- code/branches/input/src/orxonox/core/Factory.h	(revision 968)
+++ code/branches/input/src/orxonox/core/Factory.h	(revision 969)
@@ -51,6 +51,4 @@
 namespace orxonox
 {
-    class BaseObject; // Forward declaration
-
     // ###############################
     // ###         Factory         ###
Index: code/branches/input/src/orxonox/core/Identifier.h
===================================================================
--- code/branches/input/src/orxonox/core/Identifier.h	(revision 968)
+++ code/branches/input/src/orxonox/core/Identifier.h	(revision 969)
@@ -33,5 +33,5 @@
      - the name
      - a list with all objects
-     - parents and childs
+     - parents and children
      - the factory (if available)
      - the networkID that can be synchronised with the server
@@ -65,7 +65,4 @@
 namespace orxonox
 {
-    class BaseFactory; // Forward declaration
-    class BaseObject;  // Forward declaration
-
     // ###############################
     // ###       Identifier        ###
Index: code/branches/input/src/orxonox/core/Tickable.h
===================================================================
--- code/branches/input/src/orxonox/core/Tickable.h	(revision 968)
+++ code/branches/input/src/orxonox/core/Tickable.h	(revision 969)
@@ -46,6 +46,4 @@
 namespace orxonox
 {
-    //class TickFrameListener; // Forward declaration
-
     //! The Tickable interface provides a tick(dt) function, that gets called every frame.
     class _CoreExport Tickable : virtual public OrxonoxClass
Index: code/branches/input/src/orxonox/objects/Fighter.h
===================================================================
--- code/branches/input/src/orxonox/objects/Fighter.h	(revision 968)
+++ code/branches/input/src/orxonox/objects/Fighter.h	(revision 969)
@@ -7,6 +7,4 @@
 
 #include "Model.h"
-
-class TiXmlElement; // Forward declaration
 
 namespace orxonox
Index: code/branches/input/src/orxonox/objects/Model.h
===================================================================
--- code/branches/input/src/orxonox/objects/Model.h	(revision 968)
+++ code/branches/input/src/orxonox/objects/Model.h	(revision 969)
@@ -6,6 +6,4 @@
 #include "WorldEntity.h"
 #include "../tools/Mesh.h"
-
-class TiXmlElement; // Forward declaration
 
 namespace orxonox
Index: code/branches/input/src/orxonox/objects/NPC.h
===================================================================
--- code/branches/input/src/orxonox/objects/NPC.h	(revision 968)
+++ code/branches/input/src/orxonox/objects/NPC.h	(revision 969)
@@ -11,6 +11,4 @@
 
 #include "Model.h"
-
-class TiXmlElement; // Forward declaration
 
 namespace orxonox {
Index: code/branches/input/src/orxonox/objects/Projectile.h
===================================================================
--- code/branches/input/src/orxonox/objects/Projectile.h	(revision 968)
+++ code/branches/input/src/orxonox/objects/Projectile.h	(revision 969)
@@ -10,6 +10,4 @@
 namespace orxonox
 {
-    class SpaceShip; // Forward declaration
-
     class _OrxonoxExport Projectile : public WorldEntity
     {
Index: code/branches/input/src/orxonox/objects/Skybox.h
===================================================================
--- code/branches/input/src/orxonox/objects/Skybox.h	(revision 968)
+++ code/branches/input/src/orxonox/objects/Skybox.h	(revision 969)
@@ -5,6 +5,4 @@
 
 #include "core/BaseObject.h"
-
-class TiXmlElement; // Forward declaration
 
 namespace orxonox
Index: code/branches/input/src/orxonox/objects/SpaceShip.h
===================================================================
--- code/branches/input/src/orxonox/objects/SpaceShip.h	(revision 968)
+++ code/branches/input/src/orxonox/objects/SpaceShip.h	(revision 969)
@@ -10,10 +10,6 @@
 #include "../tools/BillboardSet.h"
 
-class TiXmlElement;          // Forward declaration
-
 namespace orxonox
 {
-    class ParticleInterface; // Forward declaration
-
     class _OrxonoxExport SpaceShip : public Model, public OIS::MouseListener
     {